


var bprivacyShutDownObserver = {


	   QueryInterface: function(aIID) {
	      if (aIID.equals(Components.interfaces.nsIWebProgressListener)   ||
	          aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
	          aIID.equals(Components.interfaces.nsISupports))
	               return this;
	      throw Components.results.NS_NOINTERFACE;
	   },


		register: function()
		{
		    var observerService = Components.classes["@mozilla.org/observer-service;1"]
		                          .getService(Components.interfaces.nsIObserverService);
		    observerService.addObserver(this, "quit-application-requested", false);
			//note: "quit-application-granted" sends no data value to determine if restart or shutdown
			//note: "quit-application-granted" is UNRELIABLE since not triggered by closing a window with x (upper right window corner)
			//note: "quit-application" is not triggered at all
		},

		observe: function(aSubject, aTopic, aData)
		{
		//	alert(aTopic+'   '+aData);
			if(aTopic == "quit-application-requested")
				bprivacy.onexit();
		},


};





var bprivacy = {
	prompts: Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService),
	wm: Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator),
	prefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.bprivacy."),
	mw: window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
		                   .getInterface(Components.interfaces.nsIWebNavigation)
		                   .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
		                   .rootTreeItem
		                   .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
		                   .getInterface(Components.interfaces.nsIDOMWindow),
	nsIFilePicker: Components.interfaces.nsIFilePicker,
	lsos: [],
	Stack: [],
	timerID: 0,
	tStart: null,
	tTicks: null,
	selected: null,
	Scan: 0,


	LOG: function(text)
	{
	    var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
	    consoleService.logStringMessage(text);
	},


	WindowOnEnter: function(event) {
	    if (event.keyCode == 13) { return false; }
	    return true;
	},


	openHelp: function(page)
	{
    var aBrowser =  typeof gBrowser !== 'undefined' ? gBrowser :  (typeof  bprivacy.wm.getMostRecentWindow("navigator:browser")  !== 'undefined' ? bprivacy.wm.getMostRecentWindow("navigator:browser").gBrowser : undefined);
		if(typeof aBrowser !== 'undefined')
			aBrowser.selectedTab = aBrowser.addTab(page);

		else if(bprivacyopt.WindowObjectReference == null || bprivacyopt.WindowObjectReference.closed)
		{
			try{
				bprivacyopt.WindowObjectReference = window.open(page, "", "width=800,height=600,alwaysRaised=yes,resizable=yes,scrollbars=yes,status=no");
			}catch(e){}
    }

	},


	getDoc: function()
	{
		var doc = bprivacy.mw.document;
		if(!doc)
			doc = window.document;
		return doc;
	},




	convert: function()
	{
		var PrefSrv = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		//AutoDelLSO
		try{
			if(bprivacyutils.prefs.getBoolPref("extensions.bprivacy.AutoDelLSO") == false)
				bprivacyutils.setPref("extensions.bprivacy.AutoDelLSOnExitMode", 1);
			PrefSrv.clearUserPref("extensions.bprivacy.AutoDelLSO"); //delete preference
		}catch(e){}
		//FlashAppDir
		try{
			if(bprivacyutils.prefs.getCharPref("extensions.bprivacy.flashAppDir") && String(bprivacyutils.prefs.getCharPref("extensions.bprivacy.flashAppDir")).length)
			{
				var Dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	  			Dir.initWithPath(bprivacyutils.getPref("extensions.bprivacy.flashAppDir"));
		  		if(Dir.path && Dir.exists() && Dir.isDirectory())
					bprivacy.prefs.setComplexValue("DataDir", Components.interfaces.nsILocalFile, Dir);
			}
			PrefSrv.clearUserPref("extensions.bprivacy.flashAppDir"); //delete preference
		}catch(e){}
		//DOMStorage
		try{
			if(bprivacyutils.prefs.getBoolPref("extensions.bprivacy.domstorage.allowed") == false )
			{
				bprivacyutils.setPref("extensions.bprivacy.domclear", true);
				bprivacyutils.setPref("dom.storage.enabled", true);
				PrefSrv.clearUserPref("extensions.bprivacy.domstorage.allowed"); //delete preference
			}
		}catch(e){}



		//ProtectionList
		try{
			if(bprivacyutils.getPref("extensions.bprivacy.protectedLSOList").length )
			{
				var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
				str.data = bprivacyutils.getPref("extensions.bprivacy.protectedLSOList");
				bprivacy.prefs.setComplexValue("Exclusions", Components.interfaces.nsISupportsString, str);
				PrefSrv.clearUserPref("extensions.bprivacy.protectedLSOList"); //delete preference
			}
		}catch(e){}


	},



	//startup of FireFox
	firstload: function(event)
	{
		try{
                        window.removeEventListener("load", bprivacy.firstload, true);
        		bprivacy.convert();
        		bprivacyShutDownObserver.register();


        		if(!bprivacyutils.getPref("extensions.bprivacy.initiated"))
        		{
        			bprivacyutils.setPref("extensions.bprivacy.initiated", true);
        			bprivacyutils.setPref("browser.send_pings", false);
        			bprivacyutils.setPref("extensions.bprivacy.sendpings.allowed", false);
        			bprivacy.GetFlashDir(2);//set flashApp directory preference, scan if necessary
        			//setTimeout("bprivacy.openHelp()", 25000);
        			setTimeout(function(){bprivacy.openHelp('chrome://bprivacy/content/BetterPrivacy.html');}, 25000);
        		}else
        		{
        			if(bprivacyutils.getPref("extensions.bprivacy.alwaysReScan") || !bprivacy.GetFlashDir(0))
        				bprivacy.GetFlashDir(1);
        		}
        		if(
        			( !bprivacyutils.getPref("extensions.bprivacy.sendpings.allowed") && (bprivacyutils.getPref("extensions.bprivacy.sendpings.allowed") != bprivacyutils.getPref("browser.send_pings")) )
        		)
        		{
        			//if(confirm("BetterPrivacy:\r\nThe extension detected that one or more privacy settings have been modified!\r\nPress OK to correct those values.")){
        				bprivacyutils.setPref("browser.send_pings", bprivacyutils.getPref("extensions.bprivacy.sendpings.allowed"));
        			//}
        		}
        		if(bprivacyutils.getPref("extensions.bprivacy.DelTimerInterval") < 1)
        			bprivacyutils.setPref("extensions.bprivacy.DelTimerInterval", 1);

        		if(window == bprivacy.mw)
        		{
        			if(bprivacyutils.getPref("extensions.bprivacy.domclear")){
        				bprivacy.DelDOM("startup");
        			}//AutoDelDOM
        			if(bprivacyutils.getPref("extensions.bprivacy.AutoDelLSOnStart"))
        				bprivacy.prepareDelLSO(2, null);
        			bprivacy.startDelTimer();
        		}
        		bprivacy.SetKeys();
		}catch(e){alert("An error occured while initializing BetterPrivacy\r\nPlease send the following information to the author: \r\n"+e);}
	},//end menue load






	SetKeys: function()
	{
		var kNode = document.getElementById("bprivacy.delete_key");
		if(kNode)
		{
			var keyCode = bprivacyutils.getPref("extensions.bprivacy.keycode");
			if(keyCode){
				kNode.setAttribute("disabled", false);
				kNode.setAttribute("modifiers", String(bprivacyutils.getPref("extensions.bprivacy.keymodifiers")));
				kNode.setAttribute("key", String.fromCharCode(keyCode));
			}
		}
	},





	GetDirs: function(currentDir, dirArray)
	{
		var entries;
		try{
			entries = currentDir.directoryEntries;
		}catch(e){}
		while(entries && entries.hasMoreElements())
		{
			var entry = entries.getNext();
			try{
				entry.QueryInterface(Components.interfaces.nsIFile);
				if (entry.isDirectory() && !entry.isSymlink() && !bprivacy.isSpecial(entry))
				{
					dirArray.push(entry);
					bprivacy.GetDirs(entry, dirArray);
				}
			}catch(e){bprivacy.LOG("BetterPrivacy: Failure parsing directories - " + e);}
		}
		return dirArray;
	},




	DelDirSortAlgo: function(file1, file2)
	{
		if (file1.path.length > file2.path.length)
		return -1;
		else if (file2.path.length > file1.path.length)
		return 1;
		return 0;
	},



	delDirs: function(FlashDirRoot)
	{
		if(!FlashDirRoot || !bprivacyutils.getPref("extensions.bprivacy.delDirs"))
			return;
	  	// Delete ISO8601 formated directories
		var dirArray = new Array();
		bprivacy.GetDirs(FlashDirRoot, dirArray);
		var numDirsToDelete = dirArray.length;
		dirArray.sort(bprivacy.DelDirSortAlgo);
		for(var i=0; i<numDirsToDelete; i++)
		{
			try{ //never delete non-empty directories (FF throws NS_ERROR_FILE_DIR_NOT_EMPTY if remove attribut is false)
				dirArray[i].remove(false);
			}catch(e)
			{
				if(e.name != "NS_ERROR_FILE_DIR_NOT_EMPTY")
					bprivacy.LOG("BetterPrivacy: Unable to delete directory (usually temporarily due to an open handle or missing permission)- " + dirArray[i].path);      // + " - " + e
			}
		}
		dirArray = null;
	},



	onexit: function(event)
	{
                var time = bprivacy.tStart ? bprivacy.tStart : "";
                bprivacyutils.setPref("extensions.bprivacy.timer", time);

		////try{bprivacy.mw.removeEventListener("unload", bprivacy.onexit, false);}catch(e){}
		try{
			bprivacy.mw.clearTimeout(bprivacy.timerID);
			var enumerator = bprivacy.wm.getEnumerator("navigator:browser");
		var wincount = 0;
		while(enumerator && enumerator.hasMoreElements()){
			wincount++;
			enumerator.getNext();
		}

		if(wincount == 1){
			if(bprivacyutils.getPref("extensions.bprivacy.domclear")){
				bprivacy.DelDOM("shutdown");
			}//AutoDelDOM
			bprivacy.prepareDelLSO(3, null);
		}

		}catch(e){alert("BetterPrivacy\r\nError in shutdown procedure\r\nPlease report this to the author " + e);}
        	//When a string is assigned to the returnValue property of window.event, a dialog box appears....
        	//the problem seems to be:
        	//1. when onbeforeunload is called, it will take the return value of the handler as window.event.returnValue.
        	//2. it will then parse the return value as a string (unless it is null)
        	//3. since false is parsed as a string, the dialogue box will fire, which will then pass an appropriate true/false
        	//the result is, there doesn't seem to be a way of assigning false to onbeforeunload, to prevent it from the default dialog.
	},






	DelDOM: function(inf)
	{
                var FFVersion = Components.classes["@mozilla.org/xre/app-info;1"]
                        .getService(Components.interfaces.nsIXULAppInfo).version;
                if (parseInt(FFVersion.charAt(0)) > 3)
                        return;
		var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
		file.append("webappsstore.sqlite");
		if(file.exists()) // if it exists, delete
		{
                      try{
                        file.remove(false);
                      }catch(e){
                        bprivacy.LOG("BetterPrivacy: Deletion of DOM data on " + inf + " impossible due to open handle - trying again later.");
                      }
		}
	},


	checkFlashFolder: function()
	{
		if (!bprivacy.GetFlashDir(0))
		{
			if (!bprivacyutils.getPref("extensions.bprivacy.donotaskforfolder"))
			{
				check = {value: false};
				var confirmed = bprivacy.prompts.confirmCheck(window, "BetterPrivacy", bprivacy.getString("askfornewpath"), bprivacy.getString("askfornewpath2"), check);
				bprivacyutils.setPref("extensions.bprivacy.donotaskforfolder", check.value);
				if(confirmed)
					window.openDialog('chrome://bprivacy/content/bprivacyopt.xul', '_blank', 'chrome=yes, modal=yes, resizable=yes, centerscreen=yes');
			}
		}
		return bprivacy.GetFlashDir(0);
	},


	isDefaultLSO: function(lso)
	{
                var DefaultLSORegEx = bprivacyutils.getPref("extensions.bprivacy.DefaultLSORegEx") + "(\u005c\u002f|\u005c\u005c)?$";
		var rgx_def = new RegExp(DefaultLSORegEx, 'i');
		var DefaultLSOName = new RegExp(bprivacyutils.getPref("extensions.bprivacy.DefaultLSOName"), 'i');
		var dir = String(lso.path).replace(DefaultLSOName, "");
		if( lso.file.leafName.match(DefaultLSOName) && dir.match(rgx_def) )
		      return true;
		return false;
	},


	isSettingsLSO: function(lso)
	{
                var SettingsLSORegEx = bprivacyutils.getPref("extensions.bprivacy.DefaultLSORegEx") + "(\u005c\u002f|\u005c\u005c).+";
		var rgx_def = new RegExp(SettingsLSORegEx, 'i');
		var dir = String(lso.path);
		if( dir.match(rgx_def) )
		      return true;
		return false;
	},


	isProtectedLSO: function(lso)
	{
		if(String(lso.prot).indexOf("d") >= 0 || String(lso.prot).indexOf("s") >= 0)
			return true;
		return false;
	},


	LSOtoDelete: function()
	{
		bprivacy.lsos = [];
		if(!bprivacy.checkFlashFolder())
			return 0;

		bprivacy.LoadLsos(bprivacy.GetFlashDir(0), true);
		var deleted = 0;
		//var rgx_def = new RegExp(bprivacyutils.getPref("extensions.bprivacy.DefaultLSORegEx"), 'i');
		//rgx_def += "(\u005c\u002f|\u005c\u005c)?$";
		//var DefaultLSOName = new RegExp(bprivacyutils.getPref("extensions.bprivacy.DefaultLSOName"), 'i');
		for (var x=0;x<bprivacy.lsos.length;x++)//first check number of LSO's to be deleted
		{
			try{
				var defaultCookie = bprivacy.isDefaultLSO(bprivacy.lsos[x]);
				var protectedCookie = bprivacy.isProtectedLSO(bprivacy.lsos[x]);
				//if(String(bprivacy.lsos[x].prot).indexOf("d") >= 0 || String(bprivacy.lsos[x].prot).indexOf("s") >= 0)
				//	protectedCookie = true;
				//var dir = String(bprivacy.lsos[x].path).replace(DefaultLSOName, "");
				//if( bprivacy.lsos[x].file.leafName.match(DefaultLSOName) && dir.match(rgx_def) )
				//	defaultCookie = true;
				if(!protectedCookie && (!defaultCookie || bprivacyutils.getPref("extensions.bprivacy.DefaultFlashCookieDeletion")))
					deleted++;
			}catch(e){bprivacy.LOG("BetterPrivacy: Error while counting LSOs");}
		}
		return deleted;

	},




	prepareDelLSO: function(mode, trange)  //mode 1=byTimer 2=onStartup 3=onExit
	{
		try{
			if(mode == 3) //on quit Firefox
			{
				if(bprivacyutils.getPref("extensions.bprivacy.AutoDelLSOnExitMode") === 0)  //BetterPrivacy deletion settings
				{
					if(!bprivacyutils.getPref("extensions.bprivacy.donotaskonexit"))  //show dialog, ask user
					{
						window.openDialog("chrome://bprivacy/content/bprivacyprogress.xul", "_blank", "chrome=yes, modal=yes, resizable=no, centerscreen=yes, alwaysRaised=yes", mode);
					}else    //no dialog
					{
						if(bprivacy.LSOtoDelete())
							bprivacy.DelLSO(mode, trange);
					}
				}
				else if(bprivacyutils.getPref("extensions.bprivacy.AutoDelLSOnExitMode") === 1) //Firefox automatic deletion settings (no sanitizer prompt)
				{
/*
						if(!bprivacyutils.getPref("privacy.sanitize.sanitizeOnShutdown"))
							return;
						if(!bprivacyutils.getPref("privacy.item.extensions-betterprivacy") && !bprivacyutils.getPref("privacy.cpd.extensions-betterprivacy"))
							return;
*/
            var privacyitem, privacyclear, privacysanitize;
            try{privacysanitize = bprivacyutils.getPref("privacy.sanitize.sanitizeOnShutdown");}catch(e){}
            try{privacyitem = bprivacyutils.getPref("privacy.item.extensions-betterprivacy");}catch(e){}
            try{privacyclear = bprivacyutils.getPref("privacy.clearOnShutdown.extensions-betterprivacy");}catch(e){}
						if(  !(privacysanitize === true && ( (privacyitem === true && !privacyclear) ||  privacyclear === true) )  )
							return;
						if(bprivacy.LSOtoDelete())
							bprivacy.DelLSO(mode, trange);
				}
			}else
			{
				if(bprivacy.LSOtoDelete())
					bprivacy.DelLSO(mode, trange);
			}
		}catch(e){alert("BetterPrivacy: Error in prepare delete LSO function: " + e);}
	},





	processProgressWindow: function(win, mode) //always mode 3
	{
		var deleted = bprivacy.LSOtoDelete();
		if(deleted)
		{
			check = {value: false};
			var delconfirmed = bprivacy.prompts.confirmCheck(window, bprivacy.getString("askfordeletion1"), bprivacy.getString("askfordeletion2") + " " + deleted + " " + bprivacy.getString("askfordeletion3"), bprivacy.getString("askfordeletion4"), check);
			bprivacyutils.setPref("extensions.bprivacy.donotaskonexit", check.value);
			if(delconfirmed)
				bprivacy.DelLSO(mode, null);
		}
		win.close();//keep open until here, else the processing might be aborted before finishing
	},


	DelLSO: function(mode, range)//mode 0=ClearHistory 1=byTimer 2=onStartup 3=onExit
	{
		try{
			deleted = 0;
			var DefaultLSOName = new RegExp(bprivacyutils.getPref("extensions.bprivacy.DefaultLSOName"), 'i');
			for (var x=0;x<bprivacy.lsos.length;x++)//effectively delete LSO's
			{
        			try{
        				var defaultCookie = bprivacy.isDefaultLSO(bprivacy.lsos[x]);
        				var protectedCookie = bprivacy.isProtectedLSO(bprivacy.lsos[x]);
        				var dir = String(bprivacy.lsos[x].path).replace(DefaultLSOName, "");
        				if(!protectedCookie && (!defaultCookie || bprivacyutils.getPref("extensions.bprivacy.DefaultFlashCookieDeletion")))
        				{
        						var cDate = new Date();
        						if( mode == 1 && bprivacyutils.getPref("extensions.bprivacy.useDelTimerDelay") && cDate.getTime() >= bprivacy.lsos[x].file.lastModifiedTime && cDate.getTime()-bprivacy.lsos[x].file.lastModifiedTime < bprivacyutils.getPref("extensions.bprivacy.DelTimerInterval") * 1000 )
        							continue;
        						if( mode == 0 && range && cDate.getTime() >= bprivacy.lsos[x].file.lastModifiedTime && cDate.getTime()-bprivacy.lsos[x].file.lastModifiedTime > range )
        							continue;
        						bprivacy.lsos[x].file.remove(false);
        						deleted++;
        				}
        			}catch(e){bprivacy.LOG("BetterPrivacy: Error while deleting LSO");}
			}
			bprivacyutils.setPref("extensions.bprivacy.removed", bprivacyutils.getPref("extensions.bprivacy.removed") + deleted);//statistics
			bprivacyutils.setPref("extensions.bprivacy.removedSession", bprivacyutils.getPref("extensions.bprivacy.removedSession") + deleted);//statistics
			bprivacy.delDirs(bprivacy.GetFlashDir(0)); //remove folders
			bprivacy.updateKnownLSOs();
		}catch(e){alert("BetterPrivacy: Error in delete LSO function: " + e);}
	},


	updateKnownLSOs: function()
	{
		if(bprivacy.lsos)
			bprivacyutils.setPref("extensions.bprivacy.LSOcount", bprivacy.lsos.length);
	},




	modifiedSince: function(lso)
	{
		var c = new Date(); //will hold current ticks
		var m = new Date();
		m.setTime(parseInt(lso.modified)); //modified lso ticks
		var diff = c.getTime() - m.getTime();
		return diff;
	},


	startDelTimer: function()
	{
              var tCurrent = new Date();
              bprivacy.tStart = new Date();
              var Timer = bprivacyutils.getPref("extensions.bprivacy.timer");
              if(Timer){
               var tTimer = new Date(Timer);
                     if(tTimer < tCurrent)
                          bprivacy.tStart = tTimer;
              }
              bprivacy.updateDelTimer(true);
	},




        updateDelTimer: function(initiated)
        {
                if(bprivacyutils.getPref("extensions.bprivacy.NotifyOnNewLSO"))
        	{
                      if (FlashDirRoot = bprivacy.GetFlashDir(0))
                      {
                        bprivacy.lsos = [];
                        bprivacy.LoadLsos(FlashDirRoot, false);
                        if(!initiated && bprivacyutils.getPref("extensions.bprivacy.NotifyOnNewLSO") == 1 && bprivacy.lsos.length > bprivacyutils.getPref("extensions.bprivacy.LSOcount"))
                        {
                          var count = bprivacy.lsos.length - bprivacyutils.getPref("extensions.bprivacy.LSOcount");
                          var str = count > 1 ? " LSO's have" : " LSO has";
                          var message = "BetterPrivacy detected that " + count + str + " been placed on your harddisk!";
                          bprivacy.NotifyNewLSO(bprivacy.hashString(message), message);
                        }else
                          bprivacyutils.setPref("extensions.bprivacy.NotifyOnNewLSO", 1);
                        bprivacy.updateKnownLSOs();
                      }
        	}
        	if(bprivacy.timerID)
        	       clearTimeout(bprivacy.timerID);
        	if(bprivacyutils.getPref("extensions.bprivacy.useDelTimer"))
                {
                        if(!bprivacy.tStart)
                          bprivacy.tStart = new Date();
                        var tDate = new Date();
                        tDate.setTime(tDate.getTime() - bprivacy.tStart.getTime());
                        if(tDate.getTime() / (bprivacyutils.getPref("extensions.bprivacy.DelTimerInterval") * 1000) >= 1){
                          bprivacy.prepareDelLSO(1, null);
                          bprivacy.tStart = null;
                        }
        	} else {
                        bprivacy.tStart = null;
        	}
        	//bprivacy.timerID = setTimeout("bprivacy.updateDelTimer()", 1000);
        	bprivacy.timerID = setTimeout(function(){bprivacy.updateDelTimer();}, 1000);

	},


	sortMultiDimensional: function (a,b)
	{
	    // this sorts the array using the second element
	    return ((a[1] < b[1]) ? -1 : ((a[1] > b[1]) ? 1 : 0));
	},


	NotifyNewLSO: function(value, message)
	{
		var c = new Date();
		var mins = c.getMinutes();
		if(mins < 10)
			mins = "0" + mins;
		var secs = c.getSeconds();
		if(secs < 10)
			secs = "0" + secs;
		var ModifiedLSOs = "    Timestamp: " + c.getHours() + ":" + mins + ":" + secs;
		var count = 0;
		for (var x=0;x<bprivacy.lsos.length;x++)
		{
			if(bprivacy.modifiedSince(bprivacy.lsos[x]) < 2000)
			{
				if(!count)
					ModifiedLSOs += '    Last modified:';
				ModifiedLSOs += ' "' + bprivacy.lsos[x].file.leafName + '"';
				count++;
			}
		}
		bprivacy.Notification(value, message + ModifiedLSOs);
	},



	Notification: function(value, message)
	{
	  var buttons = [{ label: "View LSOs",
	                     callback: function() { bprivacy.RemoveNotification(value); bprivacy.showBetterPrivacy(); },
	                     accessKey: null, popup: null }];
	  var nbox = window.getBrowser().getNotificationBox();
		nbox.appendNotification(message, value, "chrome://bprivacy/content/pie.png", bprivacyutils.getPref("extensions.bprivacy.NotifyPriority"), buttons);
		if(bprivacyutils.getPref("extensions.bprivacy.NotifyDuration"))
			setTimeout(function(){bprivacy.RemoveNotification(value)}, bprivacyutils.getPref("extensions.bprivacy.NotifyDuration") * 1000, value);
	},


	RemoveNotification: function(value)
	{
		if(item = window.getBrowser().getNotificationBox().getNotificationWithValue(value))
			window.getBrowser().getNotificationBox().removeNotification(item);
	},


	changeAppDir: function(event)
	{
		bprivacy.Scan = -1;
		if (event)
		{
			if (event.keyCode != 13)
				return;
			var newpath = bprivacy.getDoc().getElementById("appdir").value;

			var oldDir;
			try{
				oldDir = bprivacy.prefs.getComplexValue("DataDir", Components.interfaces.nsILocalFile);
			}catch(e){}

			if (oldDir && newpath == oldDir.path)
				return;
			if(!confirm("You changed the FlashApplication folder to: \r\n" + newpath + "\r\nDo you want to apply this modification?"))
			{
				if (oldDir)
					newpath = oldDir.path;
				else
					newpath = "";
				bprivacy.getDoc().getElementById("appdir").value = newpath;
			}
			var Dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			try{
	  			Dir.initWithPath(newpath);
				newpath = Dir;
		  		if(!Dir.path || !Dir.exists() || !Dir.isDirectory())
					newpath = null;
			}catch(e){newpath = null;}
		}else
		{
			var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(bprivacy.nsIFilePicker);
			fp.init(window, bprivacy.getString("selectDirTitle"), bprivacy.nsIFilePicker.modeGetFolder);
			var rv = fp.show();
			if ((rv != bprivacy.nsIFilePicker.returnOK) && (rv != bprivacy.nsIFilePicker.returnReplace))
				return;
			var newpath = fp.file;
		}
		if(newpath)
			bprivacy.prefs.setComplexValue("DataDir", Components.interfaces.nsILocalFile, newpath);
		bprivacy.LSOTreeShow(newpath);
		return true;
	},



	searchDir: function()
	{

		if(bprivacy.getDoc().getElementById("searchFolderID").label != bprivacy.getString("abort")){
			if(FlashDir = bprivacy.GetFlashDir(2))
				bprivacy.LSOTreeShow(FlashDir);
		}else{
			bprivacy.Scan = -1;
		}
	},



	treeView:
	{
		treeBox: null,
		selection: null,
		get rowCount()                       { return bprivacy.lsos.length; },
		setTree: function(treeBox)         { this.treeBox = treeBox; },
		isSeparator: function(idx)         { return false; },
		isSorted: function()               { return false; },
		isEditable: function(idx, column)  { return false; },
		getCellProperties: function(idx, column, prop) {},
		getColumnProperties: function(column, element, prop) {},
		getRowProperties: function(row, element, prop) {},
		getImageSrc: function() {return null;},
		isContainer: function() {return false;},
		cycleHeader: function() {},
 		getCellText: function(idx, column)
		{
			if(!bprivacy.lsos.length)
				return "";
			//else if (column.id=="folder")
			else if (column.id=="ident")
				return bprivacy.lsos[idx].ident;
			else if (column.id=="name")
				return bprivacy.lsos[idx].file.leafName;
			else if (column.id=="size")
				return bprivacy.lsos[idx].size;
			else if (column.id=="modified")
			{
				var cDate = new Date();
				cDate.setTime(parseInt(bprivacy.lsos[idx].modified));
				return cDate.toLocaleString();
			}
			else if (column.id=="prot")
			{
				if(bprivacy.lsos[idx].prot.indexOf("d") < 0 && bprivacy.lsos[idx].prot.indexOf("s") < 0)
					return bprivacy.getString("unprotected");
				else if(bprivacy.lsos[idx].prot.indexOf("d") >= 0)
					return bprivacy.getString("protectedFolder");
				else if(bprivacy.lsos[idx].prot.indexOf("s") >= 0)
					return bprivacy.getString("protectedSubFolder");
			}
			return "";
		},
	},




	LSOTreeShow: function(flashDir)
	{
		var cDate = new Date();
		if (!flashDir)
		{
			// Display error if selected directory does not exist
			bprivacy.getDoc().getElementById("appdir").setAttribute ("readonly","true");
			bprivacy.getDoc().getElementById("appdir").value = bprivacy.getString("dirNotFound");
			bprivacy.getDoc().getElementById("appdir").style.backgroundColor = "red";
			bprivacy.getDoc().getElementById("appdir").style.color = "white";
			bprivacy.getDoc().getElementById("searchFolderID").label = bprivacy.getString("searchFlashFolder");
			bprivacy.getDoc().getElementById("lsoinfo").value = "";
			bprivacy.getDoc().getElementById("tip").value = "Status " + cDate.toLocaleString();
		}
		else
		{
			bprivacy.getDoc().getElementById("appdir").removeAttribute("readonly");
			bprivacy.getDoc().getElementById("appdir").value = flashDir.path;
			bprivacy.getDoc().getElementById("appdir").style.backgroundColor = "";
			bprivacy.getDoc().getElementById("appdir").style.color = "";
			bprivacy.getDoc().getElementById("searchFolderID").label = bprivacy.getString("searchFlashFolder");
			bprivacy.getDoc().getElementById("lsoinfo").value = bprivacy.getString("listLSOs");
			bprivacy.getDoc().getElementById("tip").value = "Status " + cDate.toLocaleString();
		}
		setTimeout(function(){bprivacy.LoadLsosIntoTree(flashDir);}, 500, flashDir); //provide time to update GUI
	},



	LoadLsosIntoTree: function(flashDir)
	{

		bprivacy.lsos = [];
		if (flashDir)
			bprivacy.LoadLsos(flashDir, true);
		//bprivacy.updateGUI(flashDir, true);
		//bprivacy.TreeOnSelect(flashDir);
                bprivacy.updateGUI(true, true);
                bprivacy.TreeOnSelect();
	},



	ReloadLsos: function()
	{
		bprivacy.LSOTreeShow(bprivacy.GetFlashDir(0));
	},


	//updateGUI: function(flashDir, sort)
	updateGUI: function(sort, view)
	{
		var LSOTree = bprivacy.getDoc().getElementById("LSOViewerTree");
		if(!LSOTree)
			return;
		if (view)
		      LSOTree.view = bprivacy.treeView;
		bprivacy.updateKnownLSOs();
		bprivacy.getDoc().getElementById("lso_removed").value = bprivacyutils.getPref("extensions.bprivacy.removed");
		bprivacy.getDoc().getElementById("lso_removedSession").value = bprivacyutils.getPref("extensions.bprivacy.removedSession");
		bprivacy.getDoc().getElementById("removeAllLsos").disabled = bprivacy.lsos.length == 0;
		bprivacy.getDoc().getElementById("lsoinfo").value = "";
		if(sort)
			bprivacy.SortLSOView(null);
		else
			LSOTree.treeBoxObject.invalidate();
	},


	TreeOnSelect: function()
	{
		var LSOTree = bprivacy.getDoc().getElementById("LSOViewerTree");
		if(!LSOTree)
			return;
		//LSOTree.view = bprivacy.treeView;
		if (/*!bprivacy.lsos.length ||*/ LSOTree.currentIndex < 0 || !bprivacy.lsos[LSOTree.currentIndex])
		{
			bprivacy.getDoc().getElementById("FullPathID").value = bprivacy.getString("nothingselected");
			bprivacy.getDoc().getElementById("protectLsoDir").label = bprivacy.getString("protectDir");
			bprivacy.getDoc().getElementById("removeLso").disabled = true;
			bprivacy.getDoc().getElementById("protectLsoDir").disabled = true;
			return;
		}
		//save selection
		bprivacy.selected = bprivacy.lsos[LSOTree.currentIndex].path;
		bprivacy.getDoc().getElementById("removeLso").removeAttribute("disabled");
		bprivacy.getDoc().getElementById("protectLsoDir").removeAttribute("disabled");
		bprivacy.getDoc().getElementById("FullPathID").value = bprivacy.lsos[LSOTree.currentIndex].path;
		if(bprivacy.lsos[LSOTree.currentIndex].prot.indexOf("d") >= 0)
			bprivacy.getDoc().getElementById("protectLsoDir").label = bprivacy.getString("unprotectDir");
		else
			bprivacy.getDoc().getElementById("protectLsoDir").label = bprivacy.getString("protectDir");
	},


	getLSOProtection: function(entry)
	{
		var exp = new RegExp(entry.leafName, 'i');
		var dir = entry.path.replace(exp, "");
		dir = dir.replace(/[\\\/]$/i, "").toLowerCase();

		var prot = "";
		var protListarr = bprivacy.prefs.getComplexValue("Exclusions", Components.interfaces.nsISupportsString).data.split("|");


		var exp = new RegExp('^.*'+bprivacyutils.getPref("extensions.bprivacy.FlashDirRegEx")+'(\u005c\u002f|\u005c\u005c)', 'i');
		if(bprivacyutils.getPref("extensions.bprivacy.alwaysReScan"))
			dir = dir.replace(exp, "");
		for (var x=0;x<protListarr.length;x++)
		{
			if(!String(protListarr[x]).length)
				continue;
			var protdir = protListarr[x].toLowerCase();
			if(bprivacyutils.getPref("extensions.bprivacy.alwaysReScan"))
				protdir = protdir.replace(exp, "");
			if(dir == protdir){
				prot = "d";
				break;
			}else if(bprivacyutils.getPref("extensions.bprivacy.autosubfolders") && dir.indexOf(protdir) >= 0){
				prot = "s";
			}
		}
		return prot;
	},



	RefreshLSOProtection: function()
	{
		for (var i=0; i<bprivacy.lsos.length; i++)
			bprivacy.lsos[i].prot = bprivacy.getLSOProtection(bprivacy.lsos[i].file);
	},




	LoadLsos: function(currentDir, doFootprint)
	{
		var protListarr = bprivacy.prefs.getComplexValue("Exclusions", Components.interfaces.nsISupportsString).data.split("|");
		var entries;
		try{
                        entries = currentDir.directoryEntries;
		}catch(e){}
		if(!entries)
			bprivacy.LOG("BetterPrivacy Warning: A LSO folder is inaccessable: " + currentDir.path);
		var rgx_dir = new RegExp('^.*'+bprivacyutils.getPref("extensions.bprivacy.FlashDirRegEx"), 'i');
                var DefaultLSORegEx = bprivacyutils.getPref("extensions.bprivacy.DefaultLSORegEx") + "(\u005c\u002f|\u005c\u005c)?$";
		var rgx_def = new RegExp(DefaultLSORegEx, 'i');
		while(entries && entries.hasMoreElements())
		{
			try{
				var entry = entries.getNext();
				entry.QueryInterface(Components.interfaces.nsIFile);
				if (entry.isFile() && !entry.isSymlink() && !bprivacy.isSpecial(entry))
				{
					try{
						if (bprivacy.isLSO(entry, doFootprint))
						{
							var cDate = new Date();
							var ticks = cDate.getTime();
							var modified = ticks-entry.lastModifiedTime;
							var prot = bprivacy.getLSOProtection(entry);
							var ident = entry.path.replace(rgx_dir, "");
                                                        ident = String(ident).replace(rgx_def, "");
							ident = String(ident).match(/[^\\\/]+\.[^\\\/]+/, "");
							ident = String(ident).replace(/^[#]/, "");
							bprivacy.lsos[bprivacy.lsos.length] = new bprivacy.Lso( entry, ident, entry.fileSize, entry.path, prot, String(ticks - modified));
						}
					}catch(e){bprivacy.LOG("BetterPrivacy: An error occured while scanning folders for LSO data: " + e);}
				}
				else if (entry.isDirectory() && !entry.isSymlink() && !bprivacy.isSpecial(entry)){
					bprivacy.LoadLsos(entry, doFootprint);
				}
			}catch(e){bprivacy.LOG("BetterPrivacy: Error while scanning folders for LSO data" + e);}
		}
		protListarr = null;
	},




	Lso: function(entry, ident, size, path, prot, modified)
	{
		this.file = entry;
		this.ident = ident;
		this.name = entry.leafName;
		this.size = size;
		this.path = path;
		this.prot = prot;
		this.modified = modified;

                if (bprivacy.isDefaultLSO(this))
                        this.ident = "<default LSO>";
                else if (bprivacy.isSettingsLSO(this))
                        this.ident = ident + " <settings LSO>";
                else if (ident.substring(ident.length-4) === ".sol")
                        this.ident = "<local LSO>";

		return this;
	},


	isLSO: function(item, doFootprint)
	{
		var str;
		var dotIndex  = item.leafName.lastIndexOf('.');
		var extension = (dotIndex >= 0) ? item.leafName.substring(dotIndex+1) : "";
		if(extension.toLowerCase() != bprivacyutils.getPref("extensions.bprivacy.LSOExtension").toLowerCase())
		      return false;
		if(doFootprint)
		{
			var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			try{
                		file.initWithPath(item.path);
                		if (file.exists())
                		{
                			var hfp = bprivacyutils.getPref("extensions.bprivacy.LSOHexFootprint").split("|");//get hexfootprint
                			var istream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
                			var bstream = Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream);
                			try{
                			   istream.init(file, -1, -1, false);
                			   bstream.setInputStream(istream);
                			   str = String(bstream.readBytes(bstream.available() > hfp.length ? hfp.length : bstream.available()));//only read needed bytes
                			}catch(e){bprivacy.LOG("BetterPrivacy: HexFootPrint error 1 " + e); return false;}
                			bstream.close();
                			istream.close();
                			if(str && str.length >= hfp.length)
                			{
                			   for (var i = 0; i < hfp.length; i++) {
                                                if(hfp[i].length && str.charCodeAt(i) != hfp[i]) //compare
                                                return false;
                			    }
                			}else return false;
                		}
			}catch(e){bprivacy.LOG("BetterPrivacy: HexFootPrint error 2 " + e); return false;}
		}
		return true;
	},





	FindLSORoot: function(HomeDir, ExToFind)
	{
		if(bprivacy.Stack.length > 0)
			return; //important
		bprivacy.Stack[0] = HomeDir;
		bprivacy.Scan = 1;
		bprivacy.FindLSORootNonRecursive( ExToFind, 1);
	},


	FindLSORootNonRecursive: function(ExToFind,  done)
	{
		var finish = function(newdir){
			bprivacy.LSOTreeShow(newdir);
			bprivacy.Scan = 0;
			bprivacy.Stack = [];
		}
		var currentDir = bprivacy.Stack.pop();
		if (ExToFind.test(currentDir.leafName))
		{
			var Dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			try{
	  			Dir.initWithPath(currentDir.path);
		  		if(Dir.path && Dir.exists() && Dir.isDirectory())
					bprivacy.prefs.setComplexValue("DataDir", Components.interfaces.nsILocalFile, Dir);
				else
					Dir = null;
			}catch(e){Dir = null;}

			finish(Dir);
			return;
		}
		done++;
		var entries;
		try{
			entries = currentDir.directoryEntries;
		}catch(e){}
		while(entries && entries.hasMoreElements() && bprivacy.Scan > 0)
		{
			var entry = entries.getNext();
			entry.QueryInterface(Components.interfaces.nsIFile);
			if (entry.isDirectory() && !entry.isSymlink() && !bprivacy.isSpecial(entry))
				bprivacy.Stack.push(entry);
		}
 		if(bprivacy.Scan > 0 && bprivacy.Stack.length > 0){
			//GUI
			if(bprivacy.getDoc().getElementById("lsoinfo"))
				bprivacy.getDoc().getElementById("lsoinfo").value = bprivacy.getString("LSOFolderScan") + " ["+done+"]";
			if(bprivacy.getDoc().getElementById("searchFolderID"))
				bprivacy.getDoc().getElementById("searchFolderID").label = bprivacy.getString("abort");
			//GUI-end
			setTimeout( function(){bprivacy.FindLSORootNonRecursive( ExToFind, done)}, 1, ExToFind, done);
		}else{
			if(bprivacy.Scan > 0 && bprivacy.getDoc().getElementById("lsoinfo"))
				bprivacy.getDoc().getElementById("lsoinfo").value = bprivacy.getString("NoDirFound");
			finish(bprivacy.GetFlashDir(0));
		}
	},



	isSpecial: function(entry)
	{
		try{
			return entry.isSpecial();
		}catch(e){}
		return false; //no avail on Mac
	},



	RemoveFromLSOProtection: function(path)
	{
		var exp = new RegExp('^.*'+bprivacyutils.getPref("extensions.bprivacy.FlashDirRegEx")+'(\u005c\u002f|\u005c\u005c)', 'i');
		if(bprivacyutils.getPref("extensions.bprivacy.alwaysReScan"))
			path = path.replace(exp, "");

		var protListarr = bprivacy.prefs.getComplexValue("Exclusions", Components.interfaces.nsISupportsString).data.split("|");
		for (var x=0;x<protListarr.length;x++)
		{
			var dir = protListarr[x];
			if(bprivacyutils.getPref("extensions.bprivacy.alwaysReScan"))
				dir = dir.replace(exp, "");
			if(dir.toLowerCase() == path.toLowerCase())
				protListarr.splice(x, 1);
		}

		var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
		str.data = protListarr.join("|");
		bprivacy.prefs.setComplexValue("Exclusions", Components.interfaces.nsISupportsString, str);
		protListarr = null;
	},



	AddToLSOProtection: function(path)
	{
		var protListarr = bprivacy.prefs.getComplexValue("Exclusions", Components.interfaces.nsISupportsString).data.split("|");
		for (var x=0;x<protListarr.length;x++)
		{
			if(protListarr[x].toLowerCase() == path.toLowerCase()){
				protListarr = null;
				return;
			}
		}
		protListarr.push(path);
		var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
		str.data = protListarr.join("|");
		bprivacy.prefs.setComplexValue("Exclusions", Components.interfaces.nsISupportsString, str);

		protListarr = null;
	},





	ToggleLSOProtection: function(mode)
	{
		var LSOTree = bprivacy.getDoc().getElementById("LSOViewerTree");
		if(LSOTree.currentIndex < 0)
			return;
		var toModify = LSOTree.currentIndex;
		var path = bprivacy.lsos[toModify].path;

		var exp = new RegExp(bprivacy.lsos[toModify].file.leafName, 'i');
		path = path.replace(exp, "");
		path = path.replace(/[\\\/]$/i, "");
		if(bprivacy.lsos[toModify].prot.indexOf("d") < 0){
			bprivacy.AddToLSOProtection(path);
			bprivacy.lsos[toModify].prot = "d";
		}else
		{
			bprivacy.RemoveFromLSOProtection(path);
			bprivacy.lsos[toModify].prot = bprivacy.lsos[toModify].prot.replace(/d/g, "");
		}

		bprivacy.RefreshLSOProtection();
		//bprivacy.updateGUI(bprivacy.GetFlashDir(0), false);
		bprivacy.updateGUI(false);
		bprivacy.TreeOnSelect();
	},



	DeleteLso: function()
	{
		var LSOTree = bprivacy.getDoc().getElementById("LSOViewerTree");
		if(!bprivacy.lsos[LSOTree.currentIndex])
			return;
		try{
			if(bprivacy.lsos[LSOTree.currentIndex].file.exists())
				bprivacy.lsos[LSOTree.currentIndex].file.remove(false);
			else
				alert("BetterPrivacy: This file does not exist anymore, nothing to do");
		}catch(e){alert("BetterPrivacy error: Failed to delete that file!"); return;}
                bprivacy.lsos.splice(LSOTree.currentIndex , 1);
                LSOTree.treeBoxObject.rowCountChanged(LSOTree.currentIndex + 1 , -1);
		//bprivacy.updateGUI(bprivacy.GetFlashDir(0), false);
		bprivacy.updateGUI(false);
		bprivacy.TreeOnSelect();
		bprivacy.delDirs(bprivacy.GetFlashDir(0));
	},


	DeleteAllLsos: function()
	{
		var LSOTree = bprivacy.getDoc().getElementById("LSOViewerTree");
		var protectedCookie = false;
		for (var x=0;x<bprivacy.lsos.length;x++)
		{
			if(String(bprivacy.lsos[x].prot).indexOf("d") >= 0 || String(bprivacy.lsos[x].prot).indexOf("s") >= 0){
				protectedCookie = true;
				break;
			}
		}
		var button = 0;
		if(protectedCookie)
		{
			check = {value: false};
			var flags = bprivacy.prompts.BUTTON_POS_0 * bprivacy.prompts.BUTTON_TITLE_YES +
			            bprivacy.prompts.BUTTON_POS_1 * bprivacy.prompts.BUTTON_TITLE_NO  +
			            bprivacy.prompts.BUTTON_POS_2 * bprivacy.prompts.BUTTON_TITLE_CANCEL;
			button =bprivacy.prompts.confirmEx(null, "BetterPrivacy", bprivacy.getString("asktodeleteall"), flags, "", "", "", null, check);
			if(button == 2)
				return;
		}
		var deleted = 0;
		for (var x=0;x<bprivacy.lsos.length;x++)
		{
			protectedCookie = false;
			if(String(bprivacy.lsos[x].prot).indexOf("d") >= 0 || String(bprivacy.lsos[x].prot).indexOf("s") >= 0)
				protectedCookie = true;
			try{
				if(!(button == 1 && protectedCookie)){
					bprivacy.lsos[x].file.remove(false);
					deleted++;
				}
			}catch(e){}
		}
		if(deleted){
			bprivacy.LSOTreeShow(bprivacy.GetFlashDir(0));
			bprivacy.TreeOnSelect();
			bprivacy.delDirs(bprivacy.GetFlashDir(0));
		}
	},




	GetRootDir: function(platform)
	{
		switch (platform){
		case "windows":
			return(Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("AppData", Components.interfaces.nsILocalFile));
		break;
		case "mac1":
			return(Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ULibDir", Components.interfaces.nsILocalFile));
		break;
		case "mac2":
			return(Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("UsrPrfs", Components.interfaces.nsILocalFile));
		break;
		case "linux":
			//gets user-directory
			return(Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("Home", Components.interfaces.nsILocalFile));
		break;
		}
		return null;
	},



	GetFlashDir: function(ForceSearch)	// detection of Flash Apps directory
	{
		//ForceSearch=0: Try current preference if available (user may have set directory manually) otherwise get predifined places
		//ForceSearch=1: Ignore current preference, get predefined places (e.g. portable mode)
		//ForceSearch=2: Ignore current preference, get predefined places and if this fails do a scan (e.g. search directory)

		var FlashDir = null;
		var knownDir = null;
		var ExToFind = new RegExp('^'+bprivacyutils.getPref("extensions.bprivacy.FlashDirRegEx")+'(\u005c\u002f|\u005c\u005c)?$', 'i');

		var Dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		if(ForceSearch < 1)
		{
			var currentDir;
			try{
				currentDir = bprivacy.prefs.getComplexValue("DataDir", Components.interfaces.nsILocalFile);
			}catch(e){}

			if (currentDir)
			{
				try{
			  		if(currentDir.path && currentDir.exists() && currentDir.isDirectory())
						knownDir = currentDir;
				}catch(e){}
			}

		}

		//scan
		if(ForceSearch > 0 && !knownDir)
		{
			try{
				//windows
				if(bprivacy.GetRootDir("windows") && bprivacy.GetRootDir("windows").exists() && bprivacy.GetRootDir("windows").isDirectory())
				{
					FlashDir = bprivacy.GetRootDir("windows");
					FlashDir.append("Roaming");
					FlashDir.append("Macromedia");
					if(FlashDir.exists() && FlashDir.isDirectory())
						knownDir = FlashDir;
					if(!knownDir)
					{
						FlashDir = bprivacy.GetRootDir("windows");
						FlashDir.append("Macromedia");
						if(FlashDir.exists() && FlashDir.isDirectory())
							knownDir = FlashDir;
					}
					if(!knownDir && (!bprivacyutils.getPref("extensions.bprivacy.noAutoScan") || ForceSearch == 2))
						bprivacy.FindLSORoot(bprivacy.GetRootDir("windows"), ExToFind);
				}
			}catch(e){}
		}
		if(ForceSearch > 0 && !knownDir)
		{
			try{
				//mac1
				if(bprivacy.GetRootDir("mac1") && bprivacy.GetRootDir("mac1").exists() && bprivacy.GetRootDir("mac1").isDirectory())
				{
					FlashDir = bprivacy.GetRootDir("mac1");
					FlashDir.append("Preferences");
					FlashDir.append("Macromedia");
					if(FlashDir.exists() && FlashDir.isDirectory())
						knownDir = FlashDir;

					if(!knownDir && (!bprivacyutils.getPref("extensions.bprivacy.noAutoScan") || ForceSearch == 2))
						bprivacy.FindLSORoot(bprivacy.GetRootDir("mac1"), ExToFind);
				}
			}catch(e){}
		}
		if(ForceSearch > 0 && !knownDir)
		{
			try{
				//mac2
				if(bprivacy.GetRootDir("mac2") && bprivacy.GetRootDir("mac2").exists() && bprivacy.GetRootDir("mac2").isDirectory())
				{
					FlashDir = bprivacy.GetRootDir("mac2");
					FlashDir.append("Macromedia");
					if(FlashDir.exists() && FlashDir.isDirectory())
						knownDir = FlashDir;
					if(!knownDir && (!bprivacyutils.getPref("extensions.bprivacy.noAutoScan") || ForceSearch == 2))
						bprivacy.FindLSORoot(bprivacy.GetRootDir("mac2"), ExToFind);
				}
			}catch(e){}
		}
		if(ForceSearch > 0 && !knownDir)
		{
			try{
				//linux
				if(bprivacy.GetRootDir("linux") && bprivacy.GetRootDir("linux").exists() && bprivacy.GetRootDir("linux").isDirectory())
				{
					FlashDir = bprivacy.GetRootDir("linux");
					FlashDir.append(".macromedia");
					if(FlashDir.exists() && FlashDir.isDirectory())
						knownDir = FlashDir;
					if(!knownDir && (!bprivacyutils.getPref("extensions.bprivacy.noAutoScan") || ForceSearch == 2))
						bprivacy.FindLSORoot(bprivacy.GetRootDir("linux"), ExToFind);
				}
			}catch(e){}
		}


		try{
	  		if(knownDir.path && knownDir.exists() && knownDir.isDirectory())
			{
				bprivacy.prefs.setComplexValue("DataDir", Components.interfaces.nsILocalFile, knownDir);
				return knownDir;
			}
		}catch(e){}

		return null;
	},



	SortLSOView: function(col)
	{
		var LSOTree = bprivacy.getDoc().getElementById("LSOViewerTree");
		if(!LSOTree)
			return;
		bprivacy.SortTable(col, bprivacy.lsos, LSOTree);
	},



	SortTable: function(column, table, tree) {
		var columnName = column;
		if(!column)
		{
			if(tree.getAttribute("sortResource"))
				columnName = tree.getAttribute("sortResource");
			else
				return;
		}
		var order = tree.getAttribute("sortDirection") == "ascending" ? 1 : -1;
		//if it's already sorted by that column, reverse sort
		if (tree.getAttribute("sortResource") == column)
			order *= -1;
		columnSort = function compare(a, b)
		{
			if (bprivacy.prepareForComparison(a[columnName]) > bprivacy.prepareForComparison(b[columnName])) return 1 * order;
			if (bprivacy.prepareForComparison(a[columnName]) < bprivacy.prepareForComparison(b[columnName])) return -1 * order;
			return 0;
		}
		table.sort(columnSort);

		//setting these will make the sort option persist
		tree.setAttribute("sortDirection", order == 1 ? "ascending" : "descending");
		tree.setAttribute("sortResource", columnName);
		tree.view = bprivacy.treeView;

		//set the appropriate attributes to show to indicator
		var cols = tree.getElementsByTagName("treecol");
		for (var i = 0; i < cols.length; i++) {
			cols[i].removeAttribute("sortDirection");
		}
		bprivacy.getDoc().getElementById(columnName).setAttribute("sortDirection", order == 1 ? "ascending" : "descending");

		//redraw tree
		tree.treeBoxObject.invalidate();

		//get old selection
		tree.view.selection.select(-1);
		if(bprivacy.selected != null)
		{
			for (var i = 0; i < table.length; i++)
			{
				if (table[i].path == bprivacy.selected)
				{
					tree.view.selection.select(i);
					//scroll into view
					tree.treeBoxObject.ensureRowIsVisible(i);
					break;
				}
			}

		}

	},



	//prepares an object for easy comparison against another. for strings, lowercases them
	prepareForComparison: function(obj) {
        	if (typeof obj == "string")
        		return obj.toLowerCase();
        	return obj;
	},



	showBetterPrivacy: function(){
		try{
			var enumerator = bprivacy.wm.getEnumerator("");
			var win, awin;
			while(enumerator && enumerator.hasMoreElements()) {
				awin = enumerator.getNext();
				if(awin && awin.document && awin.document.getElementById("bprivacy-prefpane")){
					win = awin;
					break;
				}
			}
			if(!win)
				win = window.openDialog('chrome://bprivacy/content/bprivacyopt.xul', '_blank', 'chrome=yes, resizable=yes, centerscreen=yes', 1);
			//win.focus();
			setTimeout(function(){win.focus();}, 1000, win); //timeout needed to solve strange isssue with the 'Download Statusbar' addon (empty bprivacy window)
		}catch(e){alert("An error occured while initializing BetterPrivacy options window (3)\r\nPlease send the following information to the author: \r\n"+e);}
	},



	getString: function(strID){
		var str = "";
		try{
			str = bprivacy.getDoc().getElementById("bprivacy.strBundle").getString(strID);
		}catch(e){}
		return str;
	},


	hashString: function(str){
		var converter =
		  Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].
		    createInstance(Components.interfaces.nsIScriptableUnicodeConverter);

		// we use UTF-8 here, you can choose other encodings.
		converter.charset = "UTF-8";
		// result is an out parameter,
		// result.value will contain the array length
		var result = {};
		// data is an array of bytes
		var data = converter.convertToByteArray(str, result);
		var ch = Components.classes["@mozilla.org/security/hash;1"]
		                   .createInstance(Components.interfaces.nsICryptoHash);
		ch.init(ch.MD5);
		ch.update(data, data.length);
		var hash = ch.finish(false);

		// return the two-digit hexadecimal code for a byte
		function toHexString(charCode)
		{
		  return ("0" + charCode.toString(16)).slice(-2);
		}

		// convert the binary hash data to a hex string.
		var s = [toHexString(hash.charCodeAt(i)) for (i in hash)].join("");
		// s now contains your hash in hex: should be
		return s;
	},



	onKeyCode: function()
	{
		bprivacy.prepareDelLSO(0, null);
	},



  addSanitizeItem: function () {
          window.removeEventListener("load", bprivacy.addSanitizeItem, true);
          if(!bprivacyutils.getPref("extensions.bprivacy.AutoDelLSOnExitMode"))
          return;
          if (typeof Sanitizer != 'function')
          return;
          // Sanitizer will execute this
          Sanitizer.prototype.items["extensions-betterprivacy"] =
          {
          clear : function(){
            try{
              bprivacy.sanitize(window.document);
            }catch(e){}
          },
          get canClear(){
            return true;
          }
          }
  },



   addSanitizeMenuItem: function () {
      window.removeEventListener("load", bprivacy.addSanitizeMenuItem, true);
      if(!bprivacyutils.getPref("extensions.bprivacy.AutoDelLSOnExitMode"))
        return;
      if(bprivacy.isSeaMonkey)
        return;
      var prefs = document.getElementsByTagName("preferences")[0];
      if(!prefs.hasChildNodes())
        return;

      var id = prefs.lastChild.getAttribute("id");
      if (prefs && !!id)
      {
          //privacy.item.
          //privacy.cpd.
          var prefName;
          if (id.indexOf("privacy.cpd.") === 0)    //FF < 3: sanitizer dialog on exit
          {
            prefName = "privacy.cpd.extensions-betterprivacy";
            var oldPrefName = "privacy.item.extensions-betterprivacy";
            //if an old pref exists then use it
            if (typeof bprivacyutils.getPref(prefName) != 'boolean'){
              if (typeof bprivacyutils.getPref(oldPrefName) == 'boolean')
                bprivacyutils.prefs.setBoolPref(prefName, bprivacyutils.getPref(oldPrefName));
              else
                bprivacyutils.prefs.setBoolPref(prefName, true);
            }
          }
          else if (id.indexOf("privacy.") === 0)    //FF options, privacy pane, shutdown-settings
          {
            //privacy.item.
            //privacy.clearOnShutdown.
            prefName = "privacy.clearOnShutdown.extensions-betterprivacy";
            if (typeof bprivacyutils.getPref(prefName) != "boolean") {
                bprivacyutils.prefs.setBoolPref(prefName, true);
                bprivacyutils.prefs.setBoolPref("services.sync.prefs.sync.privacy.clearOnShutdown.extensions-betterprivacy", true);
            }
          }
          else{
            return;
          }
          var pref = document.createElement("preference");
          pref.setAttribute("id", prefName);
          pref.setAttribute("name", prefName);
          pref.setAttribute("type", "bool");
          pref.setAttribute("defaultValue", true);
          prefs.appendChild(pref);
          var item;
          var itemList = document.getElementById("itemList");
          if (itemList)
            item = itemList.lastChild;
          else
          {
            item = document.getElementsByTagName("checkbox");
            item = item[item.length - 1];
          }
          var check = document.createElement(itemList ? "listitem" : "checkbox");
          check.setAttribute("label", "Flash Cookies");
          check.setAttribute("preference", prefName);
          if(itemList)
          {
            check.setAttribute("type", "checkbox");
            itemList.appendChild(check);
          }
          else
          {
            if(item.parentNode.childNodes.length == 2)
            {
              var row = document.createElement("row");
              item.parentNode.parentNode.appendChild(row);
              row.insertBefore(check, null);
            }else
              item.parentNode.insertBefore(check, null);
          }
          if (typeof gSanitizePromptDialog == "object")
          {
            //pref.setAttribute("readonly", "true");
            check.setAttribute("onsyncfrompreference", "return gSanitizePromptDialog.onReadGeneric();");
          }
          pref.setElementValue(check);
          bprivacy.addSanitizeItem();
      }
   },





  sanitize: function (doc) {
        var p = doc.getElementById("privacy.cpd.extensions-betterprivacy");
        bprivacyutils.prefs.setBoolPref(p.name, p.value);
        var ticks = 0;
        if(doc.getElementById("sanitizeDurationChoice"))
        {
        	var idx = doc.getElementById("sanitizeDurationChoice").selectedIndex;
        	var currentTime = new Date();
        	switch(idx)
        	{
        	case 0: //1 hour
        	  ticks = 3600000;
        	  break;
        	case 1: //2 hours
        	  ticks = 7200000;
        	  break;
        	case 2: //4 hours
        	  ticks = 14400000;
        	  break;
        	case 3: //today
        	  ticks = (currentTime.getHours() * 60 * 60 * 1000) + (currentTime.getMinutes() * 60 * 1000) + (currentTime.getSeconds() * 1000);
        	  break;
        	}
        }
        //clear LSO data
        bprivacy.prepareDelLSO(0, ticks);
  },





	isOptionsURL: function(url) {
        	try{
                        if (url != "chrome://bprivacy/content/bprivacyopt.xul")
                          return false;
                        var gWindowManager =  Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
                        var aBrowser = gWindowManager.getMostRecentWindow("navigator:browser");
                        if (!aBrowser)
                        {
                            var rwin = gWindowManager.getMostRecentWindow("mozilla:betterprivacy");
                            if(rwin)
                               rwin.close();
                            bprivacy.prompts.alert(window, "BetterPrivacy", "BetterPrivacy requires at least one open browser window!");
                        }
                        else
                          bprivacy.showBetterPrivacy();
        	}catch(e){alert("An error occured while initializing BetterPrivacy options window (2)\r\nPlease send the following information to the author: \r\n"+e);}
        	return true;
	},



   _isSeaMonkey: null,
           get isSeaMonkey() {
            if (this._isSeaMonkey == null) {
                var appInfo=Components.classes["@mozilla.org/xre/app-info;1"]
                    .getService(Components.interfaces.nsIXULAppInfo);
                this._isSeaMonkey = appInfo.name == 'SeaMonkey';
             }
             return this._isSeaMonkey;
   },




};